﻿#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
import os
import re
import xbmc
import xbmcgui
import xbmcplugin
import xbmcaddon
PY2 = sys.version_info[0] == 2
PY3 = sys.version_info[0] == 3
if PY2:
	from urllib import quote, unquote, quote_plus, unquote_plus, urlencode  # Python 2.X
	from HTMLParser import HTMLParser  # Python 2.X
elif PY3:
	from urllib.parse import quote, unquote, quote_plus, unquote_plus, urlencode  # Python 3+
	from html.parser import HTMLParser  # Python 3+
import json
import xbmcvfs
import shutil
import socket
import time
import datetime
from bs4 import BeautifulSoup
import requests
from requests import ConnectionError, HTTPError, Timeout, RequestException
try:
	from requests.packages.urllib3.exceptions import InsecureRequestWarning
	requests.packages.urllib3.disable_warnings(InsecureRequestWarning)
except: pass


global debuging
pluginhandle = int(sys.argv[1])
addon = xbmcaddon.Addon()
addonPath = xbmc.translatePath(addon.getAddonInfo('path')).encode('utf-8').decode('utf-8')
dataPath    = xbmc.translatePath(addon.getAddonInfo('profile')).encode('utf-8').decode('utf-8')
temp           = xbmc.translatePath(os.path.join(dataPath, 'temp', '')).encode('utf-8').decode('utf-8')
defaultFanart = os.path.join(addonPath, 'fanart.jpg')
icon = os.path.join(addonPath, 'icon.png')
enableInputstream = addon.getSetting("inputstream") == "true"
enableRT = addon.getSetting("enableRemain") == "true"
preferTM = int(addon.getSetting("preferredTime"))*60
useThumbAsFanart = addon.getSetting("useThumbAsFanart") == "true"
enableAdjustment = addon.getSetting("show_settings") == "true"
enableDebug = addon.getSetting("enableDebug") == "true"
baseURL = "https://www.tele5.de/"


xbmcplugin.setContent(pluginhandle, 'movies')

if addon.getSetting("enableTitleOrder") == "true":
	xbmcplugin.addSortMethod(int(sys.argv[1]), xbmcplugin.SORT_METHOD_VIDEO_SORT_TITLE)
xbmcplugin.addSortMethod(int(sys.argv[1]), xbmcplugin.SORT_METHOD_UNSORTED)

def py2_enc(s, encoding='utf-8'):
	if PY2 and isinstance(s, unicode):
		s = s.encode(encoding)
	return s

def py2_uni(s, encoding='utf-8'):
	if PY2 and isinstance(s, str):
		s = unicode(s, encoding)
	return s

def py3dec_py2enc(d, encoding='utf-8'):
	if PY3 and isinstance(d, bytes):
		d = d.decode(encoding)
	if PY2 and isinstance(d, unicode):
		d = d.encode(encoding)
	return d

def cleanTEXT(s, encoding='utf-8'):
	parseHtml = HTMLParser()
	s = s.replace('  ', ' ').replace('&amp;', '&').replace('&#34;', '"').encode(encoding).decode(encoding)
	return parseHtml.unescape(s)

def translation(id):
	LANGUAGE = addon.getLocalizedString(id)
	LANGUAGE = py2_enc(LANGUAGE)
	return LANGUAGE

def failing(content):
	log(content, xbmc.LOGERROR)

def debug_MS(content):
	if enableDebug:
		log(content, xbmc.LOGNOTICE)

def debug(content):
	log(content, xbmc.LOGDEBUG)

def log(msg, level=xbmc.LOGNOTICE):
	msg = py2_enc(msg)
	xbmc.log("["+addon.getAddonInfo('id')+"-"+addon.getAddonInfo('version')+"]"+msg, level)

def getUrl(url, method, allow_redirects=False, verify=False, headers=False, data="", timeout=40):
	global session
	session = requests.Session()
	try:
		if not headers:
			headers = {'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:60.0) Gecko/20100101 Firefox/60.0','Accept-Encoding': 'gzip, deflate'}
		if method=="GET":
			content = session.get(url, allow_redirects=allow_redirects, verify=verify, headers=headers, data=data, timeout=timeout)
		elif method=="POST":
			content = session.post(url, data=data, allow_redirects=allow_redirects, verify=verify)
		content.raise_for_status()
		if data !="": 
			return py3dec_py2enc(content)
		else:
			return py3dec_py2enc(content.text)
	except (ConnectionError, HTTPError, Timeout, RequestException) as e:
		failure = str(e)
		DIA_CUT = failure.split('>:')[1].replace("'", "").replace(",", "").replace(")", "").strip()
		failing("(getUrl) ERROR - ERROR - ERROR : ########## {0} === {1} ##########".format(url, failure))
		xbmcgui.Dialog().notification((translation(30521).format('URL')), "ERROR = [COLOR red]{0}[/COLOR]".format(DIA_CUT), icon, 15000)
		content = ""
		return sys.exit(0)

def ADDON_operate(INPUT_STREAM):
	js_query = xbmc.executeJSONRPC('{"jsonrpc": "2.0", "method": "Addons.GetAddonDetails", "params": {"addonid":"'+INPUT_STREAM+'", "properties": ["enabled"]}, "id":1}')
	if '"enabled":false' in js_query:
		try:
			xbmc.executeJSONRPC('{"jsonrpc": "2.0", "method": "Addons.SetAddonEnabled", "params": {"addonid":"'+INPUT_STREAM+'", "enabled":true}, "id":1}')
			failing("(ADDON_operate) ERROR - ERROR - ERROR :\n##### Das benötigte Addon : *inputstream.adaptive* ist NICHT aktiviert !!! #####\n##### Es wird jetzt versucht die Aktivierung durchzuführen !!! #####")
		except: pass
	if '"error":' in js_query:
		xbmcgui.Dialog().ok(addon.getAddonInfo('id'), translation(30501))
		failing("(ADDON_operate) ERROR - ERROR - ERROR :\n##### Das benötigte Addon : *inputstream.adaptive* ist NICHT installiert !!! #####\n##### Bitte KODI-Krypton (Version 17 oder höher) installieren, Diese enthalten das erforderliche Addon im Setup !!! #####")
		return False
	if '"enabled":true' in js_query:
		return True

def index():
	addDir(translation(30601), "filme/", "listCluster", icon, CODE="moviesFIRST", TRANSMIT_URL="filme/")
	addDir(translation(30602), baseURL+"serien/", "listSeries", icon, CODE="seriesFIRST")
	addDir(translation(30603), "deintele5/", "listCluster", icon, CODE="OTHERS", TRANSMIT_URL="deintele5/")
	if enableAdjustment:
		addDir(translation(30608), "", "aSettings", icon)
		if enableInputstream:
			if ADDON_operate('inputstream.adaptive'):
				addDir(translation(30609), "", "iSettings", icon)
			else:
				addon.setSetting("inputstream", "false")
	xbmcplugin.endOfDirectory(pluginhandle)

def listMovies(url, CODE=""):
	debug_MS("(listMovies) -------------------------------------------------- START = listMovies --------------------------------------------------")
	debug_MS("(listMovies) *[0]* ### URL = {0} ### CODE = {1} ###".format(url, CODE))
	movieLIST_1 = []
	movieLIST_2 = []
	count = 0
	pos1 = 0
	pos2 = 0
	content_1 = getUrl(baseURL+"filme/", "GET")
	jDATA = re.findall('<title>Unser Filmuniversum mit Hintergrundinfos &amp; Wissenswertem - TELE 5</title.*?<script type="application/ld(.+?)</script>', content_1, re.DOTALL)
	for entries in jDATA:
		result_1 = cleanTEXT(entries)
		debug_MS("(listMovies) XXXXX VideoText-Part : "+str(result_1)+" XXXXX")
		part = result_1.split('@context":"http://schema.org"')
		debug_MS("(listMovies) ++++ Zusammenfassung der Moviesliste +++ GEFUNDENE Movies-Anzahl = {0} +++".format(len(part)-1))
		for i in range(1, len(part), 1):
			element = part[i]
			try:
				plot = re.compile('"description":(.+?)",', re.DOTALL).findall(element)[0][1:].strip()
				url1 = re.compile('"url": (.+?)",', re.DOTALL).findall(element)[0][1:].strip().replace('mediathek/', '').replace('filme-online/', 'filme/')
				if not url1.endswith('/'):
					url1 = url1+"/"
				if url1[:4] != "http" and url1[:1] != "/":
					url1 = baseURL+url1
				elif url1[:4] != "http" and url1[:1] == "/":
					url1 = baseURL+url1[1:]
				if enableRT:
					endDATE = re.compile('"endDate":(.+?)",', re.DOTALL).findall(element)[0][1:].strip() # "endDate":"2019-11-07T22:59:00Z",
					try:
						time_END = datetime.datetime.strptime(endDATE, '%Y-%m-%dT%H:%M:%SZ')
					except TypeError:
						time_END = datetime.datetime(*(time.strptime(endDATE, '%Y-%m-%dT%H:%M:%SZ')[0:6]))
					startDATE = datetime.datetime.utcnow().strftime('%Y-%m-%d %H:%M:%S')
					try:
						time_START = datetime.datetime.strptime(startDATE, '%Y-%m-%d %H:%M:%S')
					except TypeError:
						time_START = datetime.datetime(*(time.strptime(startDATE, '%Y-%m-%d %H:%M:%S')[0:6]))
					seconds = (time_END - time_START).total_seconds()
					hours = round(seconds // 3600)
					minutes = round((seconds % 3600) // 60)
					actualHOURS = str(hours).split('.')[0]
					actualMINS = str(minutes).split('.')[0]
					resultMINS = int(actualHOURS)*60+int(actualMINS)
					debug_MS("(listMovies) *[1]* ###URL-1 = {0} ###".format(url1))
					debug_MS("(listMovies) *[1]* ### ENDTIME = {0} || UTC-TIME = {1} || diff-MIN = {2} ###".format(time_END, time_START, resultMINS))
					if resultMINS < preferTM:
						if int(actualHOURS) >= 0:
							restTIME = translation(30610).format(actualHOURS.zfill(2), actualMINS.zfill(2))
						elif int(actualHOURS) < 0:
							restTIME = translation(30611)
					else: restTIME = ""
				else: restTIME = ""
				try: director = re.compile('@type": "Person", "name": (.+?)"},', re.DOTALL).findall(element)[0][1:].strip()
				except: director =""
				movieLIST_1.append([url1, plot, director, restTIME])
			except:
				pos1 += 1
				failing("(listMovies) Fehler-Eintrag-01 : {0}".format(str(element)))
				if pos1 > 1 and count == 0:
					count += 1
					xbmcgui.Dialog().notification((translation(30521).format('DISPLAY')), translation(30523), icon, 8000)
	content_2 = getUrl(url, "GET")
	result_2 = re.findall('<div class="container--videos-img">(.+?)</ul>', content_2, re.DOTALL)
	for chtml in result_2:
		if not '<div class="special-upcoming">' in chtml: # dont show items = Das kommt demnächst
			try: 
				url2 = re.compile('href="([^"]+?)"', re.DOTALL).findall(chtml)[0].strip()
				if url2[:4] != "http" and url2[:1] != "/":
					url2 = baseURL+url2
				elif url2[:4] != "http" and url2[:1] == "/":
					url2 = baseURL+url2[1:]
				matchTT = re.compile(r'<img (?:src=|data-src=)"([^"]+?)" alt="([^"]+?)"(?:>| class)', re.DOTALL).findall(chtml)
				thumb2 = matchTT[0][0].strip()
				title = cleanTitle(matchTT[0][1])
				try:
					matchDJ = re.compile('<li class="video-detail__info">(.+?)</li>', re.DOTALL).findall(chtml)[0]
					if "|" in matchDJ or "min" in matchDJ:
						duration = matchDJ.split('|')[0].replace('min', '').replace('sek', '').strip()
						duration = int(duration)*60
					else: duration =""
					if "|" in matchDJ or "Jahre" in matchDJ:
						ageRE = matchDJ.split('|')[-1].strip()
					else: ageRE =""
				except: 
					duration =""
					ageRE =""
				try:
					matchGY = re.compile('<li class="video-detail__info">(.+?)</li>', re.DOTALL).findall(chtml)[1].replace('Komödie', 'Komoedie')
					ALLg = re.compile('([A-Za-z-?]+)', re.DOTALL).findall(matchGY)
					genres = []
					for gNames in ALLg:
						genres.append(cleanTitle(gNames))
					gGenre =", ".join(genres)
					year = re.compile('([0-9]+)', re.DOTALL).findall(matchGY)[0].strip()
				except: 
					gGenre =""
					year =""
				movieLIST_2.append([url2, title, thumb2, duration, ageRE, gGenre, year])
			except:
				pos2 += 1
				failing("(listMovies) Fehler-Eintrag-02 : {0}".format(str(chtml)))
				if pos2 > 1 and count == 0:
					count += 1
					xbmcgui.Dialog().notification((translation(30521).format('DISPLAY')), translation(30523), icon, 8000)
	if movieLIST_1 and movieLIST_2:
		for url1, plot, director, restTIME in movieLIST_1:
			for url2, title, thumb2, duration, ageRE, gGenre, year in movieLIST_2:
				if (CODE =="moviesSECOND" and not "schlefaz" in url1 and url1 == url2) or (CODE =="moviesSCHLEFAZ" and "schlefaz" in url1 and url1 == url2):
					debug_MS("(listMovies) *[zus.1+2]* ### NAME = {0} || YEAR = {1} || DURATION = {2} ###".format(title+restTIME, year, duration))
					debug_MS("(listMovies) *[zus.1+2]* ### URL-1 = {0} || AGE = {1} ###".format(url1, ageRE))
					debug_MS("(listMovies) *[zus.1+2]* ### THUMB = {0} || GENRE = {1} || DIRECTOR = {2} ###".format(thumb2, gGenre, director))
					addLink(title+restTIME, url1, 'playVideo', thumb2, plot, duration, genre=gGenre, director=director, year=year, mpaa=ageRE)
	elif not movieLIST_1:
			for url2, title, thumb2, duration, ageRE, gGenre, year in movieLIST_2:
				if (CODE =="moviesSECOND" and not "schlefaz" in url2) or (CODE =="moviesSCHLEFAZ" and "schlefaz" in url2):
					debug_MS("(listMovies) *[only2]* ### NAME = {0} || YEAR = {1} || DURATION = {2} ###".format(title, year, duration))
					debug_MS("(listMovies) *[only2]* ### URL-2 = {0} || AGE = {1} ###".format(url2, ageRE))
					debug_MS("(listMovies) *[only2]* ### THUMB = {0} || GENRE = {1} ###".format(thumb2, gGenre))
					addLink(title, url2, 'playVideo', thumb2, duration=duration, genre=gGenre, year=year, mpaa=ageRE)
	debug_MS("(listMovies) ++++ Zusammenfassung der Moviesliste +++ ENDE der Moviesliste erreicht +++")
	xbmcplugin.endOfDirectory(pluginhandle)

def listSeries(url, CODE=""):
	debug_MS("(listSeries) -------------------------------------------------- START = listSeries --------------------------------------------------")
	debug_MS("(listSeries) *[0]* ### URL = {0} ### CODE = {1} ###".format(url, CODE))
	content = getUrl(url, "GET")
	count = 0
	pos1 = 0
	result = content[content.find('<div class="mediathek-page-content">')+1:]
	result = result[:result.find('<div class="content-section__headline slope__content container">')]
	part = result.split('class="special-video special-video--series slope-container slope-container--special')
	for i in range(1, len(part), 1):
		element = part[i]
		try:
			url1 = re.compile('href="([^"]+?)"', re.DOTALL).findall(element)[0].strip()
			title = re.compile('<div class="special-title">(.+?)</div>', re.DOTALL).findall(element)[0]
			title = cleanTitle(title)
			try:
				subtitle = re.compile('<div class="special-subtitle">(.+?)</div>', re.DOTALL).findall(element)[0]
				subtitle = cleanTitle(subtitle)
			except: subtitle =""
			if subtitle !="" and subtitle != title:
				title = title+" - "+subtitle
			try:
				thumb = re.compile(r'source.*?srcset="(?:.+?x, )?(.+?(?:\.jpg [0-9]+x|\.jpeg [0-9]+x|\.png [0-9]+x))', re.DOTALL).findall(element)[0].split('g ')[0].strip()+"g"
			except:
				try: thumb = re.compile('<img src="([^"]+?)"', re.DOTALL).findall(element)[0].strip()
				except: thumb = ""
			debug_MS("(listSeries) *[1]* ### NAME = {0} || URL-1 = {1} ###".format(title, url1))
			debug_MS("(listSeries) *[1]* ### newCODE = seriesSECOND || newTRANSMIT = {0} ###".format(url1))
			debug_MS("(listSeries) *[1]* ### THUMB = {0} ###".format(thumb))
			addDir(title, url1, "listCluster", thumb, CODE="seriesSECOND", TRANSMIT_URL=url1)
		except:
			pos1 += 1
			failing("(listSeries) Fehler-Eintrag-01 : {0}".format(str(element)))
			if pos1 > 1 and count == 0:
				count += 1
				xbmcgui.Dialog().notification((translation(30521).format('DISPLAY')), translation(30523), icon, 8000)
	debug_MS("(listSeries) ++++ Zusammenfassung der Seriesliste +++ ENDE der Seriesliste erreicht +++")
	xbmcplugin.endOfDirectory(pluginhandle)

def listCluster(url, image, CODE="", TRANSMIT_URL=""):
	debug_MS("(listCluster) -------------------------------------------------- START = listCluster -------------------------------------------------")
	if url[:4] != "http" and url[:1] != "/":
		url = baseURL+url
	elif url[:4] != "http" and url[:1] == "/":
		url = baseURL+url[1:]
	if TRANSMIT_URL !="" and TRANSMIT_URL[:4] != "http" and TRANSMIT_URL[:1] != "/":
		TRANSMIT_URL = baseURL+TRANSMIT_URL
	elif TRANSMIT_URL !="" and TRANSMIT_URL[:4] != "http" and TRANSMIT_URL[:1] == "/":
		TRANSMIT_URL = baseURL+TRANSMIT_URL[1:]
	debug_MS("(listCluster) ### URL = {0} ### TRANSMIT_URL = {1} ###".format(url, TRANSMIT_URL))
	debug_MS("(listCluster) ### CODE = {0} ### IMAGE = {1} ###".format(CODE, image))
	html = getUrl(url, "GET")
	if not listSeasons(html, image, CODE, TRANSMIT_URL):
		debug_MS("(listCluster) --- noSEASONS --- ### newCODE = no_SEASONS ### newTRANSMIT = {0} ###".format(url))
		debug_MS("(listCluster) --- noSEASONS --- ### IMAGE = {0} ###".format(image))
		listVideos(html, image, CODE="no_SEASONS", TRANSMIT_URL=url)
	xbmcplugin.endOfDirectory(pluginhandle)

def listSeasons(html, image, CODE, TRANSMIT_URL):
	debug_MS("(listSeasons) ------------------------------------------------ START = listSeasons -----------------------------------------------")
	response = html
	EXCLUSION = ['app', 'tele5.de/app', '/archiv', 'brain-faq', 'bumsbuster/', 'darker-net', 'darsteller/', '.de/detail', '.de/live', 'dein-muenchen', 'europa-ist', '/genre', '-facts/', 'filmfreeway', 'hellasfilmbox', 'killerpost', 'lern-woche', 'ostblockbuster', '/podcast', '/quiz', 'schlefaz.de', 'schlefaz.shop', 'trailer', 'yeehaw']
	namesENDING_1 = ['deintele5/', 'liechtenstein/playlist/', 'skandal-filme/']
	namesENDING_2 = ['deintele5/', 'd-movies/', 'skandal-filme/']
	FOUND = 0
	count = 0
	pos1 = 0
	pos2 = 0
	pos3 = 0
	pos4 = 0
	if CODE =="OTHERS" or '<div class="mediathel-nav d-flex">' in response or '<div class="content-section__headline slope__content container">' in response or '<div class="container standard-teaser">' in response or '<div class="standard-teaser__item">' in response:
		if ('<div class="mediathel-nav d-flex">' in response and not any(TRANSMIT_URL.endswith(end_1) for end_1 in namesENDING_1) and CODE !="more_selection" and CODE !="goto_episodes"):
			result_1 = re.findall('<div class="mediathel-nav d-flex">(.+?)</div>', response, re.DOTALL)
			url1 = ""
			for chtml in result_1:
				selection = re.findall('a href="([^"]+?)">([^<]+?)</a>', chtml, re.DOTALL)
				for url1, title1 in selection:
					if not any(x in url1.lower() for x in EXCLUSION) and not url1.endswith('/filme/'):
						FOUND = 1
						name = cleanTitle(title1)
						url1 = url1.replace('filme/making-of/', 'filme/makingof/playlist/')
						if url1.endswith('filme/online/'):
							newCode = "moviesSECOND"
							addDir(name, url1, "listMovies", image, CODE=newCode)
						else:
							newCode = "more_selection"
							if url1.endswith('im-bann-der-daemonen/'):
								newCode = "goto_episodes"
							addDir(name, url1, "listCluster", image, CODE=newCode)
						debug_MS("(listSeasons) *[1]* ### NAME = {0} || URL-1 = {1} || newCODE = {2} ###".format(name, url1, newCode))
				if "kalkofes-welt/" in url1:
					addDir("Premiere Klassiker", "kalkofes-welt/premiere-klassiker/", "listEpisodes", image, CODE="goto_episodes")
			if FOUND == 1: debug_MS("(listSeasons) ++++ Zusammenfassung der Seasonliste +++ GEFUNDEN in Rubrik-Nummer = {0} +++".format(FOUND))
		if not ('<div class="content-section__headline slope__content container">' in response and not '<div class="container standard-teaser">' in response) and '<div class="list--video playlist-type" data-id=' in response and CODE != "goto_episodes" and FOUND == 1:
			debug_MS("(listSeasons) *[1+1]* ~~~ VIDEO-LIST hinzugefügt ### URL = {0} ~~~".format(TRANSMIT_URL))
			addDir("VIDEO-LIST", TRANSMIT_URL, "listEpisodes", image, CODE="goto_episodes")
		if any(TRANSMIT_URL.endswith(end_2) for end_2 in namesENDING_2) and CODE !="goto_episodes":
			if TRANSMIT_URL.endswith('deintele5/'):
				addDir("[COLOR lime]* [/COLOR]Imagekampagne", "ueber-uns/imagekampagne/", "listEpisodes", baseURL+"wp-content/uploads/2019/04/TELE5_Imagekampagne_Header.jpg", CODE="goto_episodes", TRANSMIT_URL="ueber-uns/imagekampagne/")
			result_2 = re.findall('<div class="container--videos-img(.+?)(?:</ul>|</span>)', response, re.DOTALL)
			for chtml in result_2:
				if TRANSMIT_URL.endswith('deintele5/') or '<div class="video-teaser-play-wrapper">' in chtml:
					try:
						if TRANSMIT_URL.endswith('deintele5/'):
							gotoEPISODES = ['garantiert-unzensiert/', 'fsk-sex/', 'from-shame-to-fame/']
							matchUT = re.compile('class="portfolio__title portfolio__title--home-page">.*?href="([^"]+?)">([^<]+?)</a>', re.DOTALL).findall(chtml)
							url2 = matchUT[0][0].strip()
							url2 = url2.replace('friedrich-liechtenstein/', 'friedrich-liechtenstein/playlist/')
							newCode = "first_selection"
							if any(url2.endswith(goEP) for goEP in gotoEPISODES):
								newCode = "goto_episodes"
							title2 = matchUT[0][1].strip()
							nameVERS = "[COLOR lime]* [/COLOR]"+cleanTitle(title2)
							try: thumb2 = re.compile(r'source.*?srcset="(?:.+?x, )?(.+?(?:\.jpg [0-9]+x|\.jpeg [0-9]+x|\.png [0-9]+x))', re.DOTALL).findall(chtml)[0].split('g ')[0].strip()+"g"
							except: thumb2 = ""
						else:
							url2 = re.compile('href="([^"]+?)"', re.DOTALL).findall(chtml)[0].strip()
							matchTT = re.compile(r'<img (?:src=|data-src=)"([^"]+?)" alt="([^"]+?)"(?:>| class)', re.DOTALL).findall(chtml)
							thumb2 = matchTT[0][0].strip()
							title2 = matchTT[0][1].strip()
							nameVERS = cleanTitle(title2)+"[COLOR lime]  »[/COLOR]"
							newCode = "goto_episodes"
						nameORGINAL = cleanTitle(title2)
						if not any(x in url2.lower() for x in EXCLUSION):
							FOUND = 2
							if url2.endswith('schlefaz/'):
								addDir(nameVERS, url2, "listMovies", thumb2, CODE="moviesSCHLEFAZ")
							else:
								debug_MS("(listSeasons) *[2]* ### NAME = {0} || URL-2 = {1} ###".format(nameORGINAL, url2))
								debug_MS("(listSeasons) *[2]* ### newCODE = {0} || newTRANSMIT = {1} ###".format(newCode, url2))
								debug_MS("(listSeasons) *[2]* ### THUMB = {0} ###".format(thumb2))
								addDir(nameVERS, url2, "listCluster", thumb2, CODE=newCode, TRANSMIT_URL=url2)
					except:
						pos2 += 1
						failing("(listSeasons) Fehler-Eintrag-02 : {0}".format(str(chtml)))
						if pos2 > 1 and count == 0:
							count += 1
							xbmcgui.Dialog().notification((translation(30521).format('DISPLAY')), translation(30523), icon, 8000)
			if FOUND == 2: debug_MS("(listSeasons) ++++ Zusammenfassung der Seasonliste +++ GEFUNDEN in Rubrik-Nummer = {0} +++".format(FOUND))
		if ('<div class="content-section__headline slope__content container">' in response or '<div class="container standard-teaser">' in response or '<div class="standard-teaser__item">' in response) and CODE != "goto_episodes" and FOUND == 0:
			if '<div class="content-section__headline slope__content container">' in response:
				result_3 = re.findall('<div class="content-section__headline slope__content container">(.+?)<li class="special-discription">', response, re.DOTALL)
				for chtml in result_3:
					if not 'Weitere Schmankerl' in chtml and not "Besonders beliebt" in chtml: # dont show items = Empfehlungen
						try:
							url3 = re.compile('href="([^"]+?)"', re.DOTALL).findall(chtml)[0].strip()
							url3 = url3.split('/?ve_id=')[0]+'/'
							if not any(x in url3.lower() for x in EXCLUSION):
								FOUND = 3
								title3 = re.compile('<span class="svg-headline-highlight.*?">(.+?)</span>', re.DOTALL).findall(chtml)[0]
								name = cleanTitle(title3)
								debug_MS("(listSeasons) *[3]* ### NAME = {0} || URL-3 = {1} ###".format(name, url3))
								debug_MS("(listSeasons) *[3]* ### newCODE = more_selection || newTRANSMIT = {0} ###".format(url3))
								addDir(name, url3, "listCluster", image, CODE="more_selection", TRANSMIT_URL=url3)
						except:
							pos3 += 1
							failing("(listSeasons) Fehler-Eintrag-03 : {0}".format(str(chtml)))
							if pos3 > 1 and count == 0:
								count += 1
								xbmcgui.Dialog().notification((translation(30521).format('DISPLAY')), translation(30523), icon, 8000)
				if FOUND == 3: debug_MS("(listSeasons) ++++ Zusammenfassung der Seasonliste +++ GEFUNDEN in Rubrik-Nummer = {0} +++".format(FOUND))
			if '<div class="container standard-teaser">' in response or '<div class="standard-teaser__item">' in response:
				result_4 = re.findall(r'<div class=(?:"row standard__items standard-carousel slope__content|"row no-gutters">|"column-teaser column-teaser--container)(.+?)<span class="slope__bkg-container', response, re.DOTALL)
				for entries in result_4:
					part = entries.split('<div class="col')
					for i in range(1, len(part), 1):
						element = part[i]
						try:
							url4 = re.compile(r'href="?(.+?)(?:" class=| class=|" target=| target=)', re.DOTALL).findall(element)[0].strip()
							url4 = url4.replace('filme/making-of/', 'filme/makingof/playlist/')
							if not any(x in url4.lower() for x in EXCLUSION):
								FOUND = 4
								try:
									title4 = re.compile(r'class=(?:"standard-teaser_content__title">|"column-teaser--title">)(.+?)(?:</div>|</a>)', re.DOTALL).findall(element)[0]
									title4 = cleanTitle(title4)
								except:
									title4 = url4.split('/')[-2].replace('-', ' ').title().replace('Ae', 'Ä').replace('ae', 'ä').replace('Oe', 'Ö').replace('oe', 'ö').replace('Ue', 'Ü')
								try:
									subtitle4 = re.compile(r'class=(?:"standard-teaser_content__description">|"column-teaser--descriptio.*?">)(.+?)(?:</div>|</p>)', re.DOTALL).findall(element)[0]
									subtitle4 = cleanTitle(subtitle4)
								except: subtitle4 =""
								if subtitle4 !="" and subtitle4 != title4:
									title4 = title4+" - "+subtitle4
								try:
									thumb4 = re.compile(r'source.*?srcset="(?:.+?x, )?(.+?(?:\.jpg [0-9]+x|\.jpeg [0-9]+x|\.png [0-9]+x))', re.DOTALL).findall(element)[0].split('g ')[0].strip()+"g"
								except:
									try: thumb4 = re.compile('<img src="([^"]+?)"', re.DOTALL).findall(element)[0].strip()
									except: thumb4 = ""
								newCode = "more_selection"
								if url4.endswith('fressesprecher/') or url4.endswith('garantiert-unzensiert/'):
									newCode = "goto_episodes"
								debug_MS("(listSeasons) *[4]* ### NAME = {0} || URL-4 = {1} ###".format(title4, url4))
								debug_MS("(listSeasons) *[4]* ### newCODE = {0} || newTRANSMIT = {1} ###".format(newCode, url4))
								debug_MS("(listSeasons) *[4]* ### THUMB = {0} ###".format(thumb4))
								addDir(title4, url4, "listCluster", thumb4, CODE=newCode, TRANSMIT_URL=url4)
						except:
							pos4 += 1
							failing("(listSeasons) Fehler-Eintrag-04 : {0}".format(str(element)))
							if pos4 > 1 and count == 0:
								count += 1
								xbmcgui.Dialog().notification((translation(30521).format('DISPLAY')), translation(30523), icon, 8000)
				if FOUND == 4: debug_MS("(listSeasons) ++++ Zusammenfassung der Seasonliste +++ GEFUNDEN in Rubrik-Nummer = {0} +++".format(FOUND))
		if FOUND < 1:
			return False
		return True
	return False

def listEpisodes(url, image, CODE="", TRANSMIT_URL=""):
	debug_MS("(listEpisodes) ----------------------------------------------- START = listEpisodes ----------------------------------------------")
	if url[:4] != "http" and url[:1] != "/":
		url = baseURL+url
	elif url[:4] != "http" and url[:1] == "/":
		url = baseURL+url[1:]
	if TRANSMIT_URL !="" and TRANSMIT_URL[:4] != "http" and TRANSMIT_URL[:1] != "/":
		TRANSMIT_URL = baseURL+TRANSMIT_URL
	elif TRANSMIT_URL !="" and TRANSMIT_URL[:4] != "http" and TRANSMIT_URL[:1] == "/":
		TRANSMIT_URL = baseURL+TRANSMIT_URL[1:]
	debug_MS("(listEpisodes) ### URL = {0} ### TRANSMIT_URL = {1} ###".format(url, TRANSMIT_URL))
	debug_MS("(listEpisodes) ### CODE = {0} ### IMAGE = {1} ###".format(CODE, image))
	html = getUrl(url, "GET")
	listVideos(html, image, CODE, TRANSMIT_URL)
	xbmcplugin.endOfDirectory(pluginhandle)

def listVideos(html, image, CODE, TRANSMIT_URL):
	debug_MS("(listVideos) -------------------------------------------------- START = listVideos --------------------------------------------------")
	response = html
	EXCLUSION = ['Kalkofes MATTsommer -', 'KALKOFES MATTSOMMER -', 'Kalkofes Wählscheibe -', 'KALKOFES WÄHLSCHEIBE -', 'Star Trek VLOG -', 'STAR TREK VLOG -'] # hide Episodetitle that are the same as Seriesname
	EP1_unwanted = ['best of', 'jahre', 'tele 5', 'teil '] # hide title with number in Episode-Numbers
	EP2_unwanted = ['2008', '2009', '2010', '2011', '2012', '2013', '2014', '2015', '2016', '2017', '2018', '2019', '2020'] # hide number in Episode-Numbers
	COMBINATION = []
	FOUND = 0
	count = 0
	pos1 = 0
	pos2 = 0
	pos3 = 0
	pos4 = 0
	if ('<div class="list--video playlist-type" data-id=' in response or '<div class="list--video  ">' in response):
		if '<div class="list--video playlist-type" data-id=' in response:
			result_1 = re.findall('<div class="player-container">(.+?)<div class="b-player-ads">', response, re.DOTALL)
			for entries in result_1:
				part = entries.split('<div class="list--video playlist-type')
				for i in range(1, len(part), 1):
					element = part[i]
					FOUND = 11
					try:
						videoID_1 = re.compile('data-video-id="([^"]+?)"', re.DOTALL).findall(element)[0].replace('"', '').replace("'", "").strip()
						try: # grap - Plot-1
							desc = re.compile('data-des="([^"]+?)"', re.DOTALL).findall(element)[0]
							plot = cleanTitle(desc).replace('"', '“')
						except: plot = ""
						if plot == "":
							try: # grap - Plot-2
								desc = re.compile('<p class="has-drop-cap">(.+?)</div></div></div>', re.DOTALL).findall(element)[0]
								desc = desc.replace('\n\n\n', '\n').replace('\n\n', '\n')
								plot = re.sub(r'\<.*?\>', '', desc)
								plot = cleanTitle(plot)
							except: plot = ""
						try:
							duration = re.compile('data-runtime="([^"]+?)"', re.DOTALL).findall(element)[0]
							if duration !="" and "min" in duration and not "sek" in duration:
								duration = duration.rstrip('min').strip() # von hinten entfernen = s.rstrip("min")
								duration = int(duration)*60
							elif duration !="" and not "min" in duration and "sek" in duration:
								duration = duration.rstrip('sek').strip() # von hinten entfernen = s.rstrip("sek")
						except:
							duration = ""
						try: director = re.compile('data-director="([^"]+?)"', re.DOTALL).findall(element)[0]
						except: director =""
						try: genre = re.compile('data-genre="([^"]+?)"', re.DOTALL).findall(element)[0]
						except: genre =""
						try: country = re.compile('data-country="([^"]+?)"', re.DOTALL).findall(element)[0]
						except: country =""
						try: year = re.compile('data-year="([^"]+?)"', re.DOTALL).findall(element)[0]
						except: year =""
						try:
							match = re.compile('<ul class="nav justify-content-md-start mt-2 mt-sm-0">(.+?)</ul>', re.DOTALL).findall(element)[0]
							season = re.compile(r'<span class=(?:"staffel"|"tab1-overlay")>(.+?)</span>', re.DOTALL).findall(match)[0].lower().replace('s', '').replace('taffel', '').replace(' ', '').strip()
							if str(season)[:1] == "0": # von vorne entfernen = s.lstrip("0")
								season = str(season).lstrip('0')
						except: season = ""
						try: thumb = re.compile(r'class="list--video__image--bg" style="background.+?(http.+?(?:\.jpg|\.jpeg|\.png))', re.DOTALL).findall(element)[0].replace('\/', '/')
						except: thumb = ""
						title = re.compile('<div class="list--video__title">(.+?)</div>', re.DOTALL).findall(element)[0]
						title_ORIGINAL = cleanTitle(title)
						title_COPY = title_ORIGINAL
						episode = ""
						try:
							title_COPY2 = title.replace('Staffel '+str(season), '').strip()
							if not any(x in title_COPY2.lower() for x in EP1_unwanted) and CODE !="moviesFIRST":
								matchEP = re.compile('([0-9]+)', re.DOTALL).findall(title_COPY2)
								if not any(x in matchEP[0] for x in EP2_unwanted) and season !="":
									episode = int(matchEP[0])
						except: pass
						if title_COPY != "" and any(x in title_COPY for x in EXCLUSION):
							for item in EXCLUSION:
								if item in title_COPY:
									title_COPY = title_COPY.replace(item, '').strip()
						try:
							seriesname = re.compile('<h1 class="series-headline mediathek-title--wrap">(.+?)</h1>', re.DOTALL).findall(response)[0].replace('- Ganze Folge', '').replace('n online schauen', '')
							seriesname = cleanTitle(seriesname)
						except: seriesname = ""
						if title_COPY != "":
							debug_MS("(listVideos) *[1]* ### NAME = {0} || videoID_1 = {1} || DURATION = {2} ###".format(title_COPY, videoID_1, duration))
							debug_MS("(listVideos) *[1]* ### SERIE = {0} || SEASON = {1} || EPISODE = {2} ###".format(seriesname, season, episode))
							debug_MS("(listVideos) *[1]* ### THUMB = {0} || GENRE = {1} || DIRECTOR = {2} ###".format(thumb, genre, director))
							addLink(title_COPY, str(videoID_1), 'playVideo', thumb, plot, duration, season, episode, seriesname, genre, director, country=country, year=year)
					except:
						pos1 += 1
						failing("(listVideos) Fehler-Eintrag-01 : {0}".format(str(element)))
						if pos1 > 1 and count == 0:
							count += 1
							xbmcgui.Dialog().notification((translation(30521).format('DISPLAY')), translation(30523), icon, 8000)
			if FOUND == 11: debug_MS("(listVideos) ++++ Zusammenfassung der Videoliste +++ GEFUNDEN in Rubrik-Nummer = {0} +++".format(FOUND))
		if '<div class="list--video  ">' in response:
			jDATA = re.findall('<script src="https://cdn.rawgit.com/scottjehl/picturefill/3.0.2/dist/picturefill.min.js" async></script><script type="application/ld(.+?)</script>', response, re.DOTALL)
			for entries in jDATA:
				result_2 = cleanTEXT(entries)
				debug_MS("(listVideos) XXXXX VideoText-Part : "+str(result_2)+" XXXXX")
				part = result_2.split('@type": "TVEpisode"')
				debug_MS("(listVideos) ++++ Zusammenfassung der Videoliste +++ GEFUNDENE Videos-Anzahl = {0} +++".format(len(part)-1))
				for i in range(1, len(part), 1):
					element = part[i]
					FOUND = 12
					try:
						try: director = re.compile('"director": (.+?)",', re.DOTALL).findall(result_2)[0][1:].strip()
						except: director =""
						try: writer = re.compile('"author": (.+?)",', re.DOTALL).findall(result_2)[0][1:].strip()
						except: writer =""
						try: genre = re.compile('"genre": (.+?)",', re.DOTALL).findall(result_2)[0][1:].strip()
						except: genre =""
						name = re.compile('"name": "(.+?)",', re.DOTALL).findall(element)[0].encode('utf-8').strip()
						plot = re.compile('"description": (.+?)",', re.DOTALL).findall(element)[0][1:].strip()
						thumb2 = re.compile('"image": (.+?)",', re.DOTALL).findall(element)[0][1:].strip()
						episode = re.compile('"episodeNumber": (.+?)",', re.DOTALL).findall(element)[0][1:].strip()
						season = re.compile('"partOfSeason": (.+?)",', re.DOTALL).findall(element)[0][1:].strip()
						seriesname = re.compile('"partOfSeries": (.+?)"}', re.DOTALL).findall(element)[0][1:].strip()
						try:
							TIMES = re.compile('"duration": (.+?)",', re.DOTALL).findall(element)[0][1:].strip() # "duration":"P0DT1H43M51S"
							HOURS = TIMES.split('T')[1].split('H')[0]
							MINS = TIMES.split('H')[1].split('M')[0]
							SECS = TIMES.split('M')[1].split('S')[0]
							duration = int(HOURS)*3600+int(MINS)*60+int(SECS)
						except: duration =""
						if season != "" and episode != "":
							name = "[COLOR chartreuse]S"+str(season).zfill(2)+"E"+str(episode).zfill(2)+":  [/COLOR]"+name.replace('Staffel '+str(season)+' ', '').strip()
							COMBINATION.append([name, thumb2, plot, duration, season, episode, seriesname, genre, director, writer])
					except:
						pos2 += 1
						failing("(listVideos) Fehler-Eintrag-02 : {0}".format(str(element)))
						if pos2 > 1 and count == 0:
							count += 1
							xbmcgui.Dialog().notification((translation(30521).format('DISPLAY')), translation(30523), icon, 8000)
			result_3 = re.findall('<div class="player-container">(.+?)<div class="b-player-ads">', response, re.DOTALL)
			for entries in result_3:
				part = entries.split('<div class="list--video ')
				for i in range(1, len(part), 1):
					element = part[i]
					FOUND = 13
					try:
						videoID_3 = re.compile('data-nexx-video-id="([^"]+?)"', re.DOTALL).findall(element)[0].replace('"', '').replace("'", "").strip()
						thumb3 = re.compile(r'class="list--video__image--bg" style="background.+?(http.+?(?:\.jpg|\.jpeg|\.png))', re.DOTALL).findall(element)[0].replace('\/', '/')
						name3 = re.compile('<div class="list--video__title">(.+?)</div>', re.DOTALL).findall(element)[0]
						name3 = cleanTitle(name3)
						try:
							seriesname3 = re.compile('<h1 class="series-headline mediathek-title--wrap">(.+?)</h1>', re.DOTALL).findall(response)[0].replace('- Ganze Folge', '').replace('n online schauen', '')
							seriesname3 = cleanTitle(seriesname3)
						except: seriesname3 = ""
						if COMBINATION:
							for name, thumb2, plot, duration, season, episode, seriesname, genre, director, writer in COMBINATION:
								if (thumb2 !="" and thumb2 == thumb3):
									debug_MS("(listVideos) *[zus.2+3]* ### NAME = {0} || videoID_3 = {1} || DURATION = {2} ###".format(name, videoID_3, duration))
									debug_MS("(listVideos) *[zus.2+3]* ### SERIE = {0} || SEASON = {1} || EPISODE = {2} ###".format(seriesname, season, episode))
									debug_MS("(listVideos) *[zus.2+3]* ### THUMB = {0} || GENRE = {1} || DIRECTOR = {2} ###".format(thumb3, genre, director))
									addLink(name, str(videoID_3), 'playVideo', thumb3, plot, duration, season, episode, seriesname, genre, director, writer)
						else:
							debug_MS("(listVideos) *[only3]* ### NAME = {0} || videoID_3 = {1} ###".format(name3, videoID_3))
							debug_MS("(listVideos) *[only3]* ### SERIE = {0} || THUMB = {1} ###".format(seriesname3, thumb3))
							addLink(name3, str(videoID_3), 'playVideo', thumb3, seriesname=seriesname3)
					except:
						pos3 += 1
						failing("(listVideos) Fehler-Eintrag-03 : {0}".format(str(element)))
						if pos3 > 1 and count == 0:
							count += 1
							xbmcgui.Dialog().notification((translation(30521).format('DISPLAY')), translation(30523), icon, 8000)
			if FOUND == 13: debug_MS("(listVideos) ++++ Zusammenfassung der Videoliste +++ GEFUNDEN in Rubrik-Nummer = {0} +++".format(FOUND))
	else:
		if '<div class="mediathek-video-single-player">' in response and FOUND == 0:
			result_4 = re.findall('<div class="mediathek-video-single-player">(.+?)<div class="b-player-ads', response, re.DOTALL)
			for chtml in result_4:
				FOUND = 14
				try:
					videoID_4 = re.compile('data-id="([^"]+?)"', re.DOTALL).findall(chtml)[0].replace('"', '').replace("'", "").strip()
					duration = re.compile('data-runtime="([^"]+?)"', re.DOTALL).findall(chtml)[0]
					if duration !="" and "min" in duration and not "sek" in duration:
						duration = duration.rstrip('min').strip() # von hinten entfernen = s.rstrip("min")
						duration = int(duration)*60
					elif duration !="" and not "min" in duration and "sek" in duration:
						duration = duration.rstrip('sek').strip() # von hinten entfernen = s.rstrip("sek")
					newTitle = re.compile('<meta property="og:title" content="([^"]+?)" />', re.DOTALL).findall(response)[0]
					name = cleanTitle(newTitle)
					try:
						desc = re.compile('<div class="content-section__wrap drop-cap-first">(.+?)<p class="mt-custom">', re.DOTALL).findall(response)[0]
						desc += re.compile('<div class="drop-caps tele5_db.*?">(.+?)<span class="slope__bkg-container', re.DOTALL).findall(response)[0]
						plot = re.sub(r'\n|\<.*?\>', ' ', desc)
						plot = cleanTEXT(plot)
					except: plot = ""
					debug_MS("(listVideos) *[4]* ### NAME = {0} || videoID_4 = {1} || DURATION = {2} ###".format(name, videoID_4, duration))
					debug_MS("(listVideos) *[4]* ### IMAGE = {0} ###".format(image))
					addLink(name, str(videoID_4), 'playVideo', image, plot, duration)
				except:
					pos4 += 1
					failing("(listVideos) Fehler-Eintrag-04 : {0}".format(str(chtml)))
					if pos4 > 1 and count == 0:
						count += 1
						xbmcgui.Dialog().notification((translation(30521).format('DISPLAY')), translation(30523), icon, 8000)
			if FOUND == 14: debug_MS("(listVideos) ++++ Zusammenfassung der Videoliste +++ GEFUNDEN in Rubrik-Nummer = {0} +++".format(FOUND))
	if FOUND < 1:
		failing("(listVideos) ??? Evtl. ERROR ??? - Einträge-ALLE : Konnte die abgefragten Einträge NICHT auf der Webseite finden !")
		xbmcgui.Dialog().notification((translation(30522).format('[B]Videos[/B]')), translation(30524), icon, 8000)
		return sys.exit(0)

def playVideo(url):
	debug_MS("(playVideo) -------------------------------------------------- START = playVideo --------------------------------------------------")
	if url[:4] == "http":
		contentID = getUrl(url, "GET")
		match = re.findall('<div class="mediathek-video-single-player">(.+?)<div class="button-read-more-text">', contentID, re.DOTALL)
		for chtml in match:
			videoID = re.compile('data-id="([^"]+?)"', re.DOTALL).findall(chtml)[0].replace('"', '').replace("'", "").strip()
	else:
		videoID = url
	# POST https://api.nexx.cloud/v3/759/videos/byid/1610605 additionalfields=language%2Cchannel%2Cformat%2Cpersons%2Cstudio%2Clicenseby%2Cslug%2Cfileversion%2CcontentModerationAspects&addInteractionOptions=1&addStatusDetails=1&addStreamDetails=1&addFeatures=1&addCaptions=1&addScenes=1&addHotSpots=1&addBumpers=1&captionFormat=data
	debug_MS("(playVideo) ### videoID = {0} ###".format(videoID))
	finalURL = False
	try:
		contentSTREAM = getUrl("https://arc.nexx.cloud/api/video/"+videoID+".json", "GET")
		debug_MS("(playVideo) XXXXX URL-CONTENT-NeXX-1 = {0} XXXXX".format(contentSTREAM))
		result = json.loads(contentSTREAM)
		secret = ""
		if "token" in result['result']['protectiondata'] and result['result']['protectiondata']['token'] != "":
			secret = "?hdnts="+result['result']['protectiondata']['token']
		if "tokenHLS" in result['result']['protectiondata'] and result['result']['protectiondata']['tokenHLS'] != "":
			secretHLS = "?hdnts="+result['result']['protectiondata']['tokenHLS']
		else:
			secretHLS = secret
		finalURL = "https://"+result['result']['streamdata']['cdnShieldHTTP']+result['result']['streamdata']['azureLocator']+"/"+str(result['result']['general']['ID'])+"_src.ism/Manifest(format=m3u8-aapl)"+secretHLS
		# HLS-Url = https://tele5nexx.akamaized.net/a4eebb35-4bea-4801-8560-f92585bf6565/1547335_src.ism/Manifest(format=m3u8-aapl)
		log("(playVideo) HLS-stream : {0}".format(finalURL))
		listitem = xbmcgui.ListItem(path=finalURL)
		if enableInputstream:
			if ADDON_operate('inputstream.adaptive'):
				listitem.setMimeType('application/vnd.apple.mpegurl')
				listitem.setProperty('inputstreamaddon', 'inputstream.adaptive')
				listitem.setProperty('inputstream.adaptive.manifest_type', 'hls')
			else:
				addon.setSetting("inputstream", "false")
	except:
		failing("(playVideo) ##### Abspielen des Videos NICHT möglich - VideoCode : {0} - #####\n    ########## KEINEN Eintrag für NeXX- Player gefunden !!! ##########".format(url))
		xbmcgui.Dialog().notification((translation(30521).format('PLAY')), translation(30523), icon, 8000)
	if finalURL:
		listitem.setContentLookup(False)
		xbmcplugin.setResolvedUrl(pluginhandle, True, listitem)

def cleanTitle(title):
	title = py2_enc(title)
	title = title.replace('&amp;', '&').replace('&#34;', '"').replace('&#038;', '&').replace('&#39;', '\'').replace('&#039;', '\'').replace('&#196;', 'Ä').replace('&#214;', 'Ö').replace('&#220;', 'Ü').replace('&#228;', 'ä').replace('&#246;', 'ö').replace('&#252;', 'ü').replace('&#223;', 'ß').replace('&#160;', ' ')
	title = title.replace('&#192;', 'À').replace('&#193;', 'Á').replace('&#194;', 'Â').replace('&#195;', 'Ã').replace('&#197;', 'Å').replace('&#199;', 'Ç').replace('&#200;', 'È').replace('&#201;', 'É').replace('&#202;', 'Ê')
	title = title.replace('&#203;', 'Ë').replace('&#204;', 'Ì').replace('&#205;', 'Í').replace('&#206;', 'Î').replace('&#207;', 'Ï').replace('&#209;', 'Ñ').replace('&#210;', 'Ò').replace('&#211;', 'Ó').replace('&#212;', 'Ô')
	title = title.replace('&#213;', 'Õ').replace('&#215;', '×').replace('&#216;', 'Ø').replace('&#217;', 'Ù').replace('&#218;', 'Ú').replace('&#219;', 'Û').replace('&#221;', 'Ý').replace('&#222;', 'Þ').replace('&#224;', 'à')
	title = title.replace('&#225;', 'á').replace('&#226;', 'â').replace('&#227;', 'ã').replace('&#229;', 'å').replace('&#231;', 'ç').replace('&#232;', 'è').replace('&#233;', 'é').replace('&#234;', 'ê').replace('&#235;', 'ë')
	title = title.replace('&#236;', 'ì').replace('&#237;', 'í').replace('&#238;', 'î').replace('&#239;', 'ï').replace('&#240;', 'ð').replace('&#241;', 'ñ').replace('&#242;', 'ò').replace('&#243;', 'ó').replace('&#244;', 'ô')
	title = title.replace('&#245;', 'õ').replace('&#247;', '÷').replace('&#248;', 'ø').replace('&#249;', 'ù').replace('&#250;', 'ú').replace('&#251;', 'û').replace('&#253;', 'ý').replace('&#254;', 'þ').replace('&#255;', 'ÿ')
	title = title.replace('&#352;', 'Š').replace('&#353;', 'š').replace('&#376;', 'Ÿ').replace('&#402;', 'ƒ')
	title = title.replace('&#8211;', '–').replace('&#8212;', '—').replace('&#8217;', "’").replace('&#8226;', '•').replace('&#8230;', '…').replace('&#8240;', '‰').replace('&#8364;', '€').replace('&#8482;', '™').replace('&#169;', '©').replace('&#174;', '®')
	title = title.replace('&Auml;', 'Ä').replace('Ä', 'Ä').replace('&auml;', 'ä').replace('ä', 'ä').replace('&Ouml;', 'Ö').replace('Ö', 'Ö').replace('&ouml;', 'ö').replace('ö', 'ö').replace('&Uuml;', 'Ü').replace('Ü', 'Ü').replace('&uuml;', 'ü').replace('ü', 'ü').replace('&quot;', '"').replace('&szlig;', 'ß').replace('&ndash;', '-').replace('&nbsp;', ' ').replace('	', ' ')
	title = title.replace('&agrave;', 'à').replace('&aacute;', 'á').replace('&acirc;', 'â').replace('&egrave;', 'è').replace('&eacute;', 'é').replace('&ecirc;', 'ê').replace('&igrave;', 'ì').replace('&iacute;', 'í').replace('&icirc;', 'î')
	title = title.replace('&ograve;', 'ò').replace('&oacute;', 'ó').replace('&ocirc;', 'ô').replace('&ugrave;', 'ù').replace('&uacute;', 'ú').replace('&ucirc;', 'û')
	title = title.replace("\\'", "'").replace("&x27;", "'").replace("&bull;", "•").replace("&hellip;", "...").replace("&iexcl;", "¡").replace("&iquest;", "¿").replace("&rsquo;", "’").replace("&lsquo;", "‘").replace("&sbquo;", "’").replace("&rdquo;", "”").replace("&ldquo;", "“").replace("&bdquo;", "”").replace("&rsaquo;", "›").replace("&lsaquo;", "‹").replace("&raquo;", "»").replace("&laquo;", "«")
	title = title.strip()
	return title

def parameters_string_to_dict(parameters):
	paramDict = {}
	if parameters:
		paramPairs = parameters[1:].split("&")
		for paramsPair in paramPairs:
			paramSplits = paramsPair.split('=')
			if (len(paramSplits)) == 2:
				paramDict[paramSplits[0]] = paramSplits[1]
	return paramDict

def addVideoList(url, name, image):
	PL = xbmc.PlayList(1)
	listitem = xbmcgui.ListItem(name, thumbnailImage=image)
	listitem.setInfo(type="Video", infoLabels={"Title": name, "Studio": "Tele5", "mediatype": "video"})
	if useThumbAsFanart and image != icon:
		liz.setArt({'fanart': image})
	else:
		liz.setArt({'fanart': defaultFanart})
	listitem.setProperty('IsPlayable', 'true')
	listitem.setContentLookup(False)
	PL.add(url, listitem)

def addLink(name, url, mode, image, plot=None, duration=None, season=None, episode=None, seriesname=None, genre=None, director=None, writer=None, country=None, year=None, mpaa=None):
	u = sys.argv[0]+"?url="+quote_plus(url)+"&mode="+str(mode)
	liz = xbmcgui.ListItem(name, iconImage=icon, thumbnailImage=image)
	liz.setInfo(type="Video", infoLabels={"TvShowtitle": seriesname, "Title": name, "Plot": plot, "Duration": duration, "Season": season, "Episode": episode, "Genre": genre, "Director": director, "Writer": writer, "Country": country, "Year": year, "Mpaa": mpaa, "Studio": "Tele5", "mediatype": "episode"})
	liz.setArt({'poster': image})
	if useThumbAsFanart and image != icon:
		liz.setArt({'fanart': image})
	else:
		liz.setArt({'fanart': defaultFanart})
	liz.addStreamInfo('Video', {'Duration': duration})
	liz.setProperty('IsPlayable', 'true')
	liz.addContextMenuItems([(translation(30655), 'RunPlugin(plugin://{0}?mode=addVideoList&url={1}&name={2}&image={3})'.format(addon.getAddonInfo('id'), quote_plus(u), quote_plus(name), quote_plus(image)))])
	return xbmcplugin.addDirectoryItem(pluginhandle, url=u, listitem=liz)

def addDir(name, url, mode, image, plot=None, CODE="", TRANSMIT_URL=""):
	u = sys.argv[0]+"?url="+quote_plus(url)+"&mode="+str(mode)+"&image="+quote_plus(image)+"&CODE="+str(CODE)+"&TRANSMIT_URL="+quote_plus(TRANSMIT_URL)
	liz = xbmcgui.ListItem(name, iconImage=icon, thumbnailImage=image)
	liz.setInfo(type="Video", infoLabels={"Title": name, "Plot": plot, "Studio": "Tele5"})
	liz.setArt({'poster': image})
	if useThumbAsFanart and image != icon:
		liz.setArt({'fanart': image})
	else:
		liz.setArt({'fanart': defaultFanart})
	return xbmcplugin.addDirectoryItem(pluginhandle, url=u, listitem=liz, isFolder=True)

params = parameters_string_to_dict(sys.argv[2])
name = unquote_plus(params.get('name', ''))
url = unquote_plus(params.get('url', ''))
mode = unquote_plus(params.get('mode', ''))
image = unquote_plus(params.get('image', ''))
CODE = unquote_plus(params.get('CODE', ''))
TRANSMIT_URL = unquote_plus(params.get('TRANSMIT_URL', ''))

if mode == 'aSettings':
	addon.openSettings()
elif mode == 'iSettings':
	xbmcaddon.Addon('inputstream.adaptive').openSettings()
elif mode == 'listMovies':
	listMovies(url, CODE)
elif mode == 'listSeries':
	listSeries(url, CODE)
elif mode == 'listCluster':
	listCluster(url, image, CODE, TRANSMIT_URL)
elif mode == 'listEpisodes':
	listEpisodes(url, image, CODE, TRANSMIT_URL)
elif mode == 'playVideo':
	playVideo(url)
elif mode == 'addVideoList':
	addVideoList(url, name, image)
else:
	index()